#by Nikolasi
from Renderer import Renderer
from enigma import ePixmap, ePicLoad, eDVBCI_UI, eDVBCIInterfaces, eEnv, eTimer
from Tools.Directories import fileExists, SCOPE_SKIN_IMAGE, SCOPE_CURRENT_SKIN, resolveFilename

class Cicontrol3(Renderer):
    searchPaths = (eEnv.resolve('${datadir}/enigma2/%s/'),
				'/media/hdd/%s/',
				'/media/usb/%s/')
    def __init__(self):
        Renderer.__init__(self)
        self.path = 'module'
        self.slot = ["0"]
	self.nameCache = { }
	self.pngname = ""
        self.png = ''
        self.picon = ePicLoad()
        self.timermoy = eTimer()
        self.timermoy.callback.append(self.timerclock3)
        self.control = False

    def applySkin(self, desktop, parent):
	attribs = []
	for (attrib, value,) in self.skinAttributes:
	    if attrib == 'path':
		self.path = value
	    elif attrib == 'slot':
		self.slot = value		
	    else:
		attribs.append((attrib, value))			
	self.skinAttributes = attribs
	return Renderer.applySkin(self, desktop, parent)    

    GUI_WIDGET = ePixmap

    def changed(self, what):
        if self.instance:
            pngname = ''
            if what[0] != self.CHANGED_CLEAR:
                service = self.source.service
                if service:
                    NUM_CI=eDVBCIInterfaces.getInstance().getNumOfSlots()
                    if NUM_CI > 0:
                        self.timerclock3()


    def findslot1(self):
        text = ""
        slot1 = 0
        if ',' in self.slot:
            self.control = True
            slot1= int(self.slot.split(',')[0])
        else:
            self.control = False
            slot1 = int(self.slot[0])
	state = eDVBCI_UI.getInstance().getState(slot1)
	if state != -1:
	    if state == 0:
		    text = "nomodule_slot1"
	    elif state == 1:
		    text = "initmodule_slot1"
	    elif state == 2:
		    text = "ready_slot1"
	else:
		text = "nomodule_slot1"
        self.getPiconFilename(text)		

    def findslot2(self):       
        text = ""
        slot2 = None
        if ',' in self.slot:
            self.control = False
            slot2= int(self.slot.split(',')[1])
        else:
            self.control = False
            slot2 = None
        if slot2:    
	    state = eDVBCI_UI.getInstance().getState(slot2)
	    if state != -1:
	        if state == 0:
		    text = "nomodule_slot2"
	        elif state == 1:
		    text = "initmodule_slot2"
	        elif state == 2:
		    text = "ready_slot2"
	    else:
		text = "nomodule_slot2"
	else:
	    text = "nomodule_slot2"
        self.getPiconFilename(text)
        
    def getPiconFilename(self, sRef):
        pngname = ''
        pngname = self.nameCache.get(sRef, '')
        if pngname == '':
            pngname = self.findPicon(sRef)
            if pngname != '':
                self.nameCache[sRef] = pngname
            if pngname == '':
                pngname = self.nameCache.get('default', '')
                if pngname == '':
                    pngname = self.findPicon('picon_default')
                    if pngname == '':
                        tmp = resolveFilename(SCOPE_CURRENT_SKIN, "picon_default.png")
                        if fileExists(tmp):
                            pngname = tmp
                        else:
                            pngname = resolveFilename(SCOPE_SKIN_IMAGE, "skin_default/picon_default.png")
                    self.nameCache['default'] = pngname
	size = self.instance.size()
        self.picon.setPara((size.width(), size.height(), 1, 1, False, 1, '#00000000'))
        self.picon.startDecode(pngname, 0, 0, False)               
        self.png = self.picon.getData()				
	self.instance.setPixmap(self.png)               
        return pngname

    def timerclock3(self):
        if self.control == False:
                self.findslot1()
        else:
            self.findslot2()
        self.timermoy.start(2000, True)		

    def findPicon(self, serviceName):
	for path in self.searchPaths:
		pngname = (path % self.path) + serviceName + ".png"
		if fileExists(pngname):
			return pngname
	return ""

